## ros-noetic-toposens-echo-driver 2.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)

# #####################################
# Build Toposens Sensor Library (TSL) beforehand
# #####################################

set(TSL_RELATIVE_PATH
  toposens-library/toposens_sensor_library
)

include_directories(
  ${TSL_RELATIVE_PATH}/include
)

add_subdirectory(${TSL_RELATIVE_PATH})

# #####################################
# ECHO Driver Project ##
# #####################################

project(toposens_echo_driver)

add_compile_options(-std=c++17 -Werror)

set(${PROJECT_NAME}_DEPS
  cmake_modules
  dynamic_reconfigure
  genmsg
  message_generation
  message_runtime
  roscpp
  std_msgs
  toposens_msgs
  tf
  tf2_ros
)

find_package(
  catkin REQUIRED COMPONENTS
  ${${PROJECT_NAME}_DEPS}
)

find_package(Boost REQUIRED COMPONENTS system)

# #####################################
# Config ##
# #####################################

generate_dynamic_reconfigure_options(
  cfg/EchoOneDriver.cfg
)

add_service_files(
  DIRECTORY srv
  FILES RequestAdcDump.srv
)

generate_messages(
  DEPENDENCIES std_msgs
)

# ######################################
# catkin specific configuration ##
# ######################################

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS ${${PROJECT_NAME}_DEPS}
)

# #####################################
# Build ##
# #####################################

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  include
  ${Boost_INCLUDE_DIR}
  ${catkin_INCLUDE_DIRS}
)

add_subdirectory(src)

install(
  DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)
install(
  DIRECTORY launch param
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== src/CMakeLists.txt ===
#############
## Library ##
#############

add_library(${PROJECT_NAME}
  adc_dump.cpp
  echo_driver.cpp
  lib_utils.cpp
  ros_utils.cpp
)

add_dependencies(${PROJECT_NAME}
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  toposens-sensor-library
)

install(
  TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

################
## Executable ##
################

add_executable(${PROJECT_NAME}_node
  ts_echo_driver_node.cpp
)

add_dependencies(${PROJECT_NAME}_node
  ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
)

target_link_libraries(${PROJECT_NAME}_node
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
)

install(
  TARGETS ${PROJECT_NAME}_node
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  COMPONENT main
)

add_executable(request_adc_dump
  ts_request_adc_dump_node.cpp
)

add_dependencies(request_adc_dump
  ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
)

target_link_libraries(request_adc_dump
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
)

install(
  TARGETS request_adc_dump
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  COMPONENT main
)

=== toposens-library/examples/CMakeLists.txt ===
##
## Copyright (c) Toposens GmbH 2021. All rights reserved.
##

cmake_minimum_required(VERSION 3.5.1)
set (CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# set the project name
project(toposens-sensor-library-examples)

add_library(example_common 
            example_common.h
            example_common.c)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# add n-frame-single-shot-example executable
add_executable(n_frames_single_shot_example n_frames_single_shot_example.c )
target_link_libraries(n_frames_single_shot_example toposens-sensor-library example_common)

# add n-frame-single-shot-example executable
add_executable(n_frames_single_shot_example_uart n_frames_single_shot_example_uart.c )
target_link_libraries(n_frames_single_shot_example_uart toposens-sensor-library example_common)

# add adc-dumpfile-save-example executable
add_executable(adc_dump_save_example adc_dump_save_example.c )
target_link_libraries(adc_dump_save_example toposens-sensor-library example_common)

# add logging-example executable
add_executable(log_message_example log_message_example.c )
target_link_libraries(log_message_example toposens-sensor-library example_common)

# add regular printf
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DREGULAR_PRINTF")

find_program(CLANG_TIDY_COMMAND NAMES clang-tidy)
if(NOT CLANG_TIDY_COMMAND)
  message("Clang-tidy not found!")
else()
  set(CMAKE_C_CLANG_TIDY
      clang-tidy;
      -header-filter=.;
      )
endif()

=== toposens-library/toposens_sensor_library/CMakeLists.txt ===
##
## Copyright (c) Toposens GmbH 2021. All rights reserved.
##

cmake_minimum_required(VERSION 3.5.1)

# set the project name
project(toposens-sensor-library VERSION 1.1.3 DESCRIPTION "toposens sensor library")

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_INSTALL_PREFIX "/usr")
message( "CMAKE_CURRENT_SOURCE_DIR: "  ${CMAKE_CURRENT_SOURCE_DIR})

add_compile_options(-Wall -Wextra -Werror -Wno-unused-function -Wno-unused-variable)

set(INCLUDE_FILES 
${CMAKE_CURRENT_SOURCE_DIR}/src/linux
${CMAKE_CURRENT_SOURCE_DIR}/config
)

if($ENV{TOPOSENSDEBUG})
  set(CMAKE_BUILD_TYPE Debug)
  message("Building Debug type")
endif()

find_program(CLANG_TIDY_COMMAND NAMES clang-tidy)
if(NOT CLANG_TIDY_COMMAND)
  message("Clang-tidy not found!")
else()
  set(CMAKE_C_CLANG_TIDY
      clang-tidy;
      -header-filter=.;
      )
endif()
set(SOURCE_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/linux/socketinterface.c
  ${CMAKE_CURRENT_SOURCE_DIR}/src/linux/uartinterface.c
)



message( "INCLUDE_FILES: "  ${INCLUDE_FILES})
message( "SOURCE_FILES: "  ${SOURCE_FILES})

include_directories(
  include
)

# add the library
add_library(${PROJECT_NAME} SHARED src/sensor_lib.c ${SOURCE_FILES})
link_directories(${INCLUDE_FILES})

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(${PROJECT_NAME} PRIVATE Threads::Threads -dynamic)

#install directive
install(TARGETS ${PROJECT_NAME} DESTINATION lib)
install(FILES include/toposens/sensor_lib.h DESTINATION include/toposens)
install(FILES include/toposens/custom_structs.h DESTINATION include/toposens)
install(FILES include/toposens/custom_types.h DESTINATION include/toposens)
install(FILES include/toposens/message_flags.h DESTINATION include/toposens)
install(FILES include/toposens/config/sensor_lib_config.h DESTINATION include/toposens/config)

=== debian/changelog ===
ros-noetic-toposens-echo-driver (2.3.2-2buster) buster; urgency=high

  * fix formatting error in toposens-library
  * Contributors: Baris Yazici

 -- Dennis Maier <maier@toposens.com>  Wed, 26 Jan 2022 23:00:00 -0000

ros-noetic-toposens-echo-driver (2.3.1-2buster) buster; urgency=high

  * Minor clean-up and bug fixes
  * Contributors: Baris Yazici, Dennis Maier

 -- Dennis Maier <maier@toposens.com>  Mon, 25 Oct 2021 22:00:00 -0000

ros-noetic-toposens-echo-driver (2.3.0-2buster) buster; urgency=high

  * Introduce toposens_echo_driver package
  * Update maintainers
  * Minor bug fixes
  * Contributors: Baris Yazici, Dennis Maier

 -- Dennis Maier <maier@toposens.com>  Wed, 22 Sep 2021 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-toposens-echo-driver
Section: misc
Priority: optional
Maintainer: Dennis Maier <maier@toposens.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-cmake-modules, ros-noetic-dynamic-reconfigure, ros-noetic-genmsg, ros-noetic-message-generation, ros-noetic-message-runtime, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-tf, ros-noetic-tf2-ros, ros-noetic-toposens-msgs
Homepage: https://toposens.com
Standards-Version: 3.9.2

Package: ros-noetic-toposens-echo-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-cmake-modules, ros-noetic-dynamic-reconfigure, ros-noetic-genmsg, ros-noetic-message-generation, ros-noetic-message-runtime, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-tf, ros-noetic-tf2-ros, ros-noetic-toposens-msgs
Description: ROS device driver for communication with TS ECHO sensors on a CAN bus

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-toposens-echo-driver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
